﻿using System.Collections.ObjectModel;
using System.ComponentModel;
namespace XamDataTreeBug
{
    public class SimpleViewModel : INotifyPropertyChanged
    {
        public SimpleViewModel()
        {
            mIsEnabled = true;
            mIsExpanded = false;
            mIsSelected = false;
        }
        public event PropertyChangedEventHandler PropertyChanged;

        private void RaisePropertyChanged(string property)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(property));
            }
        }

        private SimpleViewModel mParent;

        public SimpleViewModel Parent
        {
            get
            {
                return mParent;
            }
            set
            {
                mParent = value;
                RaisePropertyChanged("Parent");
            }
        }

        private ObservableCollection<SimpleViewModel> mChildren;

        public ObservableCollection<SimpleViewModel> Children
        {
            get
            {
                return mChildren;
            }
            set
            {
                if (mChildren != null)
                {
                    mChildren.CollectionChanged -= mChildren_CollectionChanged;
                }
                mChildren = value;
                if (mChildren != null)
                {
                    mChildren.CollectionChanged += mChildren_CollectionChanged;
                }

                RaisePropertyChanged("Children");
            }
        }

        void mChildren_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
        }

        private string mText;

        public string Text
        {
            get
            {
                return mText;
            }
            set
            {
                mText = value;
                RaisePropertyChanged("Text");
            }
        }

        private bool mIsEnabled;

        public bool IsEnabled
        {
            get
            {
                return mIsEnabled;
            }
            set
            {
                mIsEnabled = value;
                RaisePropertyChanged("IsEnabled");
            }
        }

        private bool mIsSelected;

        public bool IsSelected
        {
            get
            {
                return mIsSelected;
            }
            set
            {
                mIsSelected = value;
                RaisePropertyChanged("IsSelected");
            }
        }

        private bool mIsExpanded;

        public bool IsExpanded
        {
            get
            {
                return mIsExpanded;
            }
            set
            {
                mIsExpanded = value;
                RaisePropertyChanged("IsExpanded");
            }
        }





    }
}